<template>
  <v-container class="pa-0">
    <div class="mb-4 d-flex align-center">
      <span class="font-weight-bold">PAX</span>
      <v-badge v-if="paxList && paxList.length > 0" :content="paxList.length" inline data-cy="PaxListCountBadge"
        class="inverted standalone">
      </v-badge>
      <v-badge v-if="nbrPaxErrors && nbrPaxErrors > 0" :content="nbrPaxErrors + ' Erreurs'" inline
        data-cy="PaxListErrorsBadge" class="standalone" color="error">
      </v-badge>
      <v-badge v-if="nbrPaxDuplicates && nbrPaxDuplicates > 0" :content="nbrPaxDuplicates + ' Doublons'" inline
        data-cy="PaxListWarningsBadge" class="standalone" color="warning">
      </v-badge>
    </div>

    <div class="mb-8 d-flex justify-space-between align-center">
      <div class="flex w-100 d-flex align-center">
        <v-text-field v-model="query" placeholder="Recherche" data-cy="PaxListSearchInput" clearable density="compact" plain rounded
          variant="outlined" class="mr-6" max-width="400" color="primary" hide-details>
          <template v-if="!query" #append-inner>
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-checkbox hide-details v-if="nbrPaxErrors && nbrPaxErrors > 0" v-model="errorFilter" color="black" class="mr-6"
          data-cy="PaxListErrorsFilterBtn" label="Afficher les erreurs">
        </v-checkbox>

        <v-checkbox hide-details v-if="nbrPaxDuplicates && nbrPaxDuplicates > 0" v-model="duplicateFilter" color="black"
          data-cy="PaxListWarningsFilterBtn" label="Afficher les doublons">
        </v-checkbox>
      </div>
      <v-spacer></v-spacer>

      <v-btn icon size="36" data-cy="PaxListDeleteBtn" class="mr-2"
        :disabled="!paxsSelected || paxsSelected.length < 1 || flight.archived" flat @click="askDeletePaxs()">
        <v-icon>delete</v-icon>
      </v-btn>

      <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddPaxBtn" :disabled="flight.archived"
        @click="askCreateEditPax()">
        <v-icon left>add</v-icon>
        Ajouter passager
      </v-btn>
    </div>

    <v-data-table v-model="paxsSelected" :headers="headers" :search="query" :items="paxListFiltered"
      class="airvam-table" :items-per-page="-1" hide-default-footer density="compact" fixed-header multi-sort show-select
      checkbox-color="primary" :custom-sort="customSort" :sort-by="[{ key: 'atr' }]"
      loading-text="Chargement des PAX ..." no-results-text="Aucun PAX ne correspond à cette recherche"
      no-data-text="La liste des PAX est vide">
      <template #item.atr="{ item }">
        <div class="row-badges font-weight-bold">
          <v-badge v-if="item.hasError" :content="'Erreur'" inline class="dense" color="error">
          </v-badge>
          <v-badge v-if="item.isDuplicate" :content="'Doublon'" inline class="dense" color="warning">
          </v-badge>
        </div>
        {{ item.atr }}
      </template>
      <template #item.departure="{ item }">
        {{ item.departure ? item.departure.oaci : '' }}
      </template>
      <template #item.arrival="{ item }">
        {{ item.arrival ? item.arrival.oaci : '' }}
      </template>
      <template #item.rank="{ item }">
        {{ item.rank ? item.rank.name : '' }}
      </template>
      <template #item.luggageWeight="{ item }">
        <div :class="{ 'cell-warning': item.luggageWeight == null }">
          {{ item.luggageWeight }}
        </div>
      </template>
      <template #item.category="{ item }">
        <div :class="{ 'cell-warning': !item.category }">
          {{ item.category }}
        </div>
      </template>
      <template #item.actions="{ item }">
        <div class="d-flex align-center">
          <v-btn icon size="x-small" flat data-cy="PaxEditBtn" class="mr-1 action" :disabled="flight.archived"
            @click="askCreateEditPax(item)">
            <v-icon>edit</v-icon>
          </v-btn>
          <v-btn icon size="x-small" flat class="action" data-cy="PaxDeleteBtn" :disabled="flight.archived"
            @click="askDeletePax(item)">
            <v-icon>delete</v-icon>
          </v-btn>
        </div>
      </template>
    </v-data-table>

    <div ref="wrapperScrollbarDiv" class="scrollbar-wrapper">
      <div ref="scrollbarDiv" :style="{ width: scrollBarWidth + 'px' }">
      </div>
    </div>

    <LazyFlightsCasePaxDialog v-if="paxDialog && editedPax" v-model="paxDialog" :pax="editedPax" :legs="flight.legs"
      @confirm="createEditPax" @close="close" />

    <LazyConfirmDialog v-if="deleteDialog" v-model="deleteDialog" :dialog-text="deleteDialogText"
      :dialog-title="deleteDialogTitle" @confirm="deletePax" @close="close" />
  </v-container>
</template>

<script setup lang="ts">
import type { VDataTable } from 'vuetify/components/VDataTable';
import { required, max, integer, between } from "@vee-validate/rules";
import { customSort } from "../../../mixins/utilsMixin";
import { decimalValidate } from "~/plugins/veevalidate";
import { Pax } from "~/dto/pax.dto";
import { Flight } from "~/dto/flight.dto";

const props = defineProps<{
  flight: Flight,
  paxList: Pax[]
}>()

const emit = defineEmits(['hasErrors', 'deletePax', 'createEditPax'])

const query = ref('');
const editedPax: Ref<Pax | null> = ref(null);
const paxsSelected: Ref<Pax[]> = ref([]);
const paxListFiltered: Ref<Pax[]> = ref([]);
const deleteMultiplePaxs = ref(false);
const duplicateFilter = ref(false);
const errorFilter = ref(false);
const paxDialog = ref(false);
const deleteDialog = ref(false);
const deleteDialogTitle = ref('');
const deleteDialogText = ref('');
const nbrPaxDuplicates = ref(0);
const nbrPaxErrors = ref(0);
const scrollBarWidth = ref(0);
const wrapperScrollbarDiv: Ref<any> = ref(null);

const askCreateEditPax = (pax?: Pax) => {
  if (!pax) {
    pax = new Pax();
  }
  editedPax.value = Object.assign({}, pax);
  paxDialog.value = true;
}

const askDeletePax = (pax: Pax) => {
  editedPax.value = Object.assign({}, pax);
  deleteDialogTitle.value = `Suppression PAX`;
  deleteDialogText.value = `Êtes-vous sûr de vouloir supprimer le PAX "${editedPax.value.firstName} ${editedPax.value.lastName}" ?`;
  if (pax.animals && pax.animals.length > 0) {
    deleteDialogText.value += `\n Les animaux associés à ce PAX seront également supprimés.`;
  }
  deleteDialog.value = true;
}

const askDeletePaxs = () => {
  deleteDialogTitle.value = `Suppression PAXs`;
  deleteDialogText.value = `Êtes-vous sûr de vouloir supprimer ${paxsSelected.value.length} PAXs ?`;
  if (paxsSelected.value.findIndex(p => p.animals && p.animals.length > 0) >= 0) {
    deleteDialogText.value += `\n Les animaux associés à ces PAXs seront également supprimés.`;
  }
  deleteMultiplePaxs.value = true;
  deleteDialog.value = true;
}

const close = () => {
  deleteDialog.value = false;
  paxDialog.value = false;
  editedPax.value = null;
  deleteMultiplePaxs.value = false;
}

const createEditPax = () => {
  emit('createEditPax', editedPax.value);
  close();
}

const deletePax = () => {
  if (deleteMultiplePaxs.value) {
    paxsSelected.value.forEach(p => {
      emit('deletePax', Object.assign({}, p));
    });
  } else {
    emit('deletePax', editedPax.value);
  }
  close();
}

const countDuplicates = () => {
  const result = Object.values(props.paxList.reduce((r: any | Pax, e: any | Pax) => {
    const k = `${e.firstName}|${e.lastName}|${e.rank?.id}`;
    if (!r[k]) r[k] = { ...e, count: 1 }
    else r[k].count += 1;
    return r;
  }, {}));
  result.forEach((r: any | Pax) => {
    const k = `${r.firstName}|${r.lastName}|${r.rank?.id}`;
    if (r.count > 1) {
      props.paxList.map(p => {
        if (`${p.firstName}|${p.lastName}|${p.rank?.id}` === k) {
          p.isDuplicate = true;
        }
        return p;
      });
    } else {
      const paxFound = props.paxList.find(p => `${p.firstName}|${p.lastName}|${p.rank?.id}` === k);
      if (paxFound) paxFound.isDuplicate = false
    }
  });
  nbrPaxDuplicates.value = props.paxList.filter(p => p.isDuplicate).length;
}

const countErrors = () => {
  props.paxList.map(p => {
    const isValid = (!p.atr || max(p.atr, { length: 20 }))
      && required(p.arrival)
      && (!p.number || (integer(p.number)) && between(p.number, { min: 1, max: 999 }))
      && required(p.weight) && decimalValidate(p.weight) && between(p.weight, {
        min: 0,
        max: 999
      })
      && (!p.luggageWeight || (decimalValidate(p.luggageWeight).valid && between(p.luggageWeight, {
        min: 0,
        max: 999
      })))
      && (!p.gender || max(p.gender, { length: 50 }))
      && required(p.lastName) && max(p.lastName, { length: 50 })
      && required(p.firstName) && max(p.firstName, { length: 50 })
      && required(p.rank)
      && (!p.category || max(p.category, { length: 50 }))
      && (!p.militaryId || max(p.militaryId, { length: 50 }))
      && required(p.unit)
      && required(p.nationality) && max(p.nationality, { length: 50 })
      && (!p.observations || max(p.observations, { length: 255 }))
      && !!p.legs && p.legs.length > 0;
    p.hasError = !isValid;
    return p;
  });
  nbrPaxErrors.value = props.paxList.filter(p => p.hasError).length;
  emit('hasErrors', nbrPaxErrors.value > 0);
}

const filterPaxs = () => {
  if (nbrPaxErrors.value < 1) {
    errorFilter.value = false;
  }
  if (nbrPaxDuplicates.value < 1) {
    duplicateFilter.value = false;
  }
  paxsSelected.value = [];
  paxListFiltered.value = props.paxList.filter(p => {
    let toReturn = true;
    if (duplicateFilter.value) {
      toReturn = p.isDuplicate;
      if (toReturn) {
        return toReturn;
      }
    }
    if (errorFilter.value) {
      toReturn = p.hasError;
    }
    return toReturn;
  });
}

const computeScrollbar = () => {
  const tableObserver = new ResizeObserver(entries => {
    entries.forEach(entry => {
      scrollBarWidth.value = entry.contentRect.width ? entry.contentRect.width : 0;
    });
  });

  const tableElement = document.getElementsByTagName('table')[0];
  tableObserver.observe(tableElement);

  const wrapperScrollbarEl = wrapperScrollbarDiv.value;
  const tableScrollableEl = document.getElementsByClassName('v-data-table__wrapper')[0];
  wrapperScrollbarEl.addEventListener('scroll', () => {
    tableScrollableEl.scrollLeft = wrapperScrollbarEl.scrollLeft;
  });
}

watch(() => props.paxList, () => {
  countDuplicates();
  countErrors();
  filterPaxs();
})

watch(duplicateFilter, () => {
  filterPaxs();
})

watch(errorFilter, () => {
  filterPaxs();
})

onMounted(() => {
  countDuplicates();
  countErrors();
  filterPaxs();
  computeScrollbar();
})

const headers = [
  { title: 'ATR #', value: 'atr', width: '140px' },
  { title: 'Départ', value: 'departure' },
  { title: 'Arrivée', value: 'arrival' },
  { title: 'PAX nbr', value: 'number' },
  { title: 'Poids', value: 'weight' },
  { title: 'Poids bagage', value: 'luggageWeight' },
  { title: 'Genre', value: 'gender' },
  { title: 'Nom', value: 'lastName' },
  { title: 'Prénom', value: 'firstName' },
  { title: 'Grade', value: 'rank' },
  { title: 'Catégorie', value: 'category' },
  { title: 'Id militaire', value: 'militaryId' },
  { title: 'Date de naissance', value: 'birthdate' },
  { title: 'Unité', value: 'unit' },
  { title: 'Nationalité', value: 'nationality' },
  { title: 'Observations', value: 'observations' },
  { title: '', value: 'actions', sortable: false, cellProps: { class: 'sticky-right' } },
] as VDataTable['$props']['headers']
</script>

<style lang="scss">
.v-data-table--fixed-header .v-data-table {
  &__wrapper {
    overflow: hidden;
  }

  .row-badges {
    display: flex;
    position: absolute;
    top: 0;

    &>.v-badge:first-child .v-badge__wrapper {
      margin-left: 0;
    }
  }
}

.scrollbar-wrapper {
  height: 10px;
  width: calc(80% - 32px);
  overflow-x: auto;
  overflow-y: hidden;
  position: fixed;
  bottom: 64px;

  &>div {
    height: 10px;
  }
}
</style>
